diff -Nru jdk24u-jdk-24-29.orig/make/hotspot/src/native/dtrace/generateJvmOffsets.cpp jdk24u-jdk-24-29/make/hotspot/src/native/dtrace/generateJvmOffsets.cpp
--- jdk24u-jdk-24-29.orig/make/hotspot/src/native/dtrace/generateJvmOffsets.cpp	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/make/hotspot/src/native/dtrace/generateJvmOffsets.cpp	2024-12-29 15:20:25.107269598 +0100
@@ -0,0 +1,316 @@
+/*
+ * Copyright (c) 2003, 2019, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * This is to provide sanity check in jhelper.d which compares SCCS
+ * versions of generateJvmOffsets.cpp used to create and extract
+ * contents of __JvmOffsets[] table.
+ * The __JvmOffsets[] table is located in generated JvmOffsets.cpp.
+ *
+ * GENOFFS_SCCS_VER 34
+ */
+
+#include <stdio.h>
+#include <strings.h>
+
+/* A workaround for private and protected fields */
+#define private   public
+#define protected public
+
+#include <proc_service.h>
+#include "gc/shared/collectedHeap.hpp"
+#include "memory/heap.hpp"
+#include "oops/compressedOops.hpp"
+#include "runtime/vmStructs.hpp"
+
+typedef enum GEN_variant {
+        GEN_OFFSET = 0,
+        GEN_INDEX  = 1,
+        GEN_TABLE  = 2
+} GEN_variant;
+
+#ifdef COMPILER1
+#ifdef ASSERT
+
+/*
+ * To avoid the most part of potential link errors
+ * we link this program with -z nodefs .
+ *
+ * But for 'debug1' and 'fastdebug1' we still have to provide
+ * a particular workaround for the following symbols below.
+ * It will be good to find out a generic way in the future.
+ */
+
+#pragma weak tty
+
+#if defined(i386) || defined(__i386) || defined(__amd64)
+#pragma weak noreg
+#endif /* i386 */
+
+LIR_Opr LIR_OprFact::illegalOpr = (LIR_Opr) 0;
+
+address StubRoutines::_call_stub_return_address = NULL;
+
+StubQueue* AbstractInterpreter::_code = NULL;
+
+#endif /* ASSERT */
+#endif /* COMPILER1 */
+
+#define GEN_OFFS_NAME(Type,Name,OutputType)             \
+  switch(gen_variant) {                                 \
+  case GEN_OFFSET:                                      \
+    printf("#define OFFSET_%-33s %ld\n",                \
+            #OutputType #Name, offset_of(Type, Name));  \
+    break;                                              \
+  case GEN_INDEX:                                       \
+    printf("#define IDX_OFFSET_%-33s %d\n",             \
+            #OutputType #Name, index++);                \
+    break;                                              \
+  case GEN_TABLE:                                       \
+    printf("\tOFFSET_%s,\n", #OutputType #Name);        \
+    break;                                              \
+  }
+
+#define GEN_OFFS(Type,Name)                             \
+  GEN_OFFS_NAME(Type,Name,Type)
+
+#define GEN_SIZE(Type)                                  \
+  switch(gen_variant) {                                 \
+  case GEN_OFFSET:                                      \
+    printf("#define SIZE_%-35s %ld\n",                  \
+            #Type, sizeof(Type));                       \
+    break;                                              \
+  case GEN_INDEX:                                       \
+    printf("#define IDX_SIZE_%-35s %d\n",               \
+            #Type, index++);                            \
+    break;                                              \
+  case GEN_TABLE:                                       \
+    printf("\tSIZE_%s,\n", #Type);                      \
+    break;                                              \
+  }
+
+#define GEN_VALUE(String,Value)                         \
+  switch(gen_variant) {                                 \
+  case GEN_OFFSET:                                      \
+    printf("#define %-40s %d\n", #String, Value);       \
+    break;                                              \
+  case GEN_INDEX:                                       \
+    printf("#define IDX_%-40s %d\n", #String, index++); \
+    break;                                              \
+  case GEN_TABLE:                                       \
+    printf("\t" #String ",\n");                         \
+    break;                                              \
+  }
+
+void gen_prologue(GEN_variant gen_variant) {
+    const char *suffix = "Undefined-Suffix";
+
+    switch(gen_variant) {
+      case GEN_OFFSET: suffix = ".h";        break;
+      case GEN_INDEX:  suffix = "Index.h";   break;
+      case GEN_TABLE:  suffix = ".cpp";      break;
+    }
+
+    printf("/*\n");
+    printf(" * JvmOffsets%s !!!DO NOT EDIT!!! \n", suffix);
+    printf(" * The generateJvmOffsets program generates this file!\n");
+    printf(" */\n\n");
+    switch(gen_variant) {
+
+      case GEN_OFFSET:
+      case GEN_INDEX:
+        break;
+
+      case GEN_TABLE:
+        printf("#include \"JvmOffsets.h\"\n");
+        printf("\n");
+        printf("int __JvmOffsets[] = {\n");
+        break;
+    }
+}
+
+void gen_epilogue(GEN_variant gen_variant) {
+    if (gen_variant != GEN_TABLE) {
+        return;
+    }
+    printf("};\n\n");
+    return;
+}
+
+int generateJvmOffsets(GEN_variant gen_variant) {
+  int index = 0;        /* It is used to generate JvmOffsetsIndex.h */
+  int pointer_size = sizeof(void *);
+  int data_model = (pointer_size == 4) ? PR_MODEL_ILP32 : PR_MODEL_LP64;
+
+  gen_prologue(gen_variant);
+
+  GEN_VALUE(DATA_MODEL, data_model);
+  GEN_VALUE(POINTER_SIZE, pointer_size);
+#if COMPILER1_AND_COMPILER2
+  GEN_VALUE(COMPILER, 3);
+#elif COMPILER1
+  GEN_VALUE(COMPILER, 1);
+#elif COMPILER2
+  GEN_VALUE(COMPILER, 2);
+#else
+  GEN_VALUE(COMPILER, 0);
+#endif // COMPILER1 && COMPILER2
+  printf("\n");
+
+  GEN_OFFS(CollectedHeap, _reserved);
+  GEN_OFFS(MemRegion, _start);
+  GEN_OFFS(MemRegion, _word_size);
+  GEN_SIZE(HeapWord);
+  printf("\n");
+
+  GEN_OFFS(VMStructEntry, typeName);
+  GEN_OFFS(VMStructEntry, fieldName);
+  GEN_OFFS(VMStructEntry, address);
+  GEN_SIZE(VMStructEntry);
+  printf("\n");
+
+  GEN_VALUE(MAX_METHOD_CODE_SIZE, max_method_code_size);
+#if defined(i386) || defined(__i386) || defined(__amd64)
+  GEN_VALUE(OFFSET_interpreter_frame_sender_sp, -1 * pointer_size);
+  GEN_VALUE(OFFSET_interpreter_frame_method, -3 * pointer_size);
+  GEN_VALUE(OFFSET_interpreter_frame_bcp_offset, -7 * pointer_size);
+#endif
+
+  GEN_OFFS(Klass, _name);
+  GEN_OFFS(ConstantPool, _pool_holder);
+  printf("\n");
+
+  GEN_VALUE(OFFSET_HeapBlockHeader_used, (int) offset_of(HeapBlock::Header, _used));
+  GEN_OFFS(oopDesc, _metadata);
+  printf("\n");
+
+  GEN_VALUE(AccessFlags_NATIVE, JVM_ACC_NATIVE);
+  GEN_VALUE(ConstMethod_has_linenumber_table, ConstMethod::_has_linenumber_table);
+  GEN_OFFS(AccessFlags, _flags);
+  GEN_OFFS(Symbol, _length);
+  GEN_OFFS(Symbol, _body);
+  printf("\n");
+
+  GEN_OFFS(Method, _constMethod);
+  GEN_OFFS(Method, _access_flags);
+  printf("\n");
+
+  GEN_OFFS(ConstMethod, _constants);
+  GEN_OFFS(ConstMethod, _flags);
+  GEN_OFFS(ConstMethod, _code_size);
+  GEN_OFFS(ConstMethod, _name_index);
+  GEN_OFFS(ConstMethod, _signature_index);
+  printf("\n");
+
+  GEN_OFFS(CodeHeap, _memory);
+  GEN_OFFS(CodeHeap, _segmap);
+  GEN_OFFS(CodeHeap, _log2_segment_size);
+  printf("\n");
+
+  GEN_OFFS(VirtualSpace, _low_boundary);
+  GEN_OFFS(VirtualSpace, _high_boundary);
+  GEN_OFFS(VirtualSpace, _low);
+  GEN_OFFS(VirtualSpace, _high);
+  printf("\n");
+
+  /* We need to use different names here because of the template parameter */
+  GEN_OFFS_NAME(GrowableArray<CodeHeap*>, _data, GrowableArray_CodeHeap);
+  GEN_OFFS_NAME(GrowableArray<CodeHeap*>, _len, GrowableArray_CodeHeap);
+  printf("\n");
+
+  GEN_OFFS(CodeBlob, _name);
+  GEN_OFFS(CodeBlob, _header_size);
+  GEN_OFFS(CodeBlob, _content_begin);
+  GEN_OFFS(CodeBlob, _code_begin);
+  GEN_OFFS(CodeBlob, _code_end);
+  GEN_OFFS(CodeBlob, _data_offset);
+  GEN_OFFS(CodeBlob, _frame_size);
+  printf("\n");
+
+  GEN_OFFS(nmethod, _method);
+  GEN_OFFS(nmethod, _dependencies_offset);
+  GEN_OFFS(nmethod, _metadata_offset);
+  GEN_OFFS(nmethod, _scopes_data_begin);
+  GEN_OFFS(nmethod, _scopes_pcs_offset);
+  GEN_OFFS(nmethod, _handler_table_offset);
+  GEN_OFFS(nmethod, _deopt_handler_begin);
+  GEN_OFFS(nmethod, _orig_pc_offset);
+
+  GEN_OFFS(PcDesc, _pc_offset);
+  GEN_OFFS(PcDesc, _scope_decode_offset);
+
+  printf("\n");
+
+  GEN_OFFS(NarrowPtrStruct, _base);
+  GEN_OFFS(NarrowPtrStruct, _shift);
+  printf("\n");
+
+  GEN_VALUE(SIZE_HeapBlockHeader, (int) sizeof(HeapBlock::Header));
+  GEN_SIZE(oopDesc);
+  GEN_SIZE(ConstantPool);
+  printf("\n");
+
+  GEN_SIZE(PcDesc);
+  GEN_SIZE(Method);
+  GEN_SIZE(ConstMethod);
+  GEN_SIZE(nmethod);
+  GEN_SIZE(CodeBlob);
+  GEN_SIZE(BufferBlob);
+  GEN_SIZE(SingletonBlob);
+  GEN_SIZE(RuntimeStub);
+  GEN_SIZE(SafepointBlob);
+
+  gen_epilogue(gen_variant);
+  printf("\n");
+
+  fflush(stdout);
+  return 0;
+}
+
+const char *HELP =
+    "HELP: generateJvmOffsets {-header | -index | -table} \n";
+
+int main(int argc, const char *argv[]) {
+    GEN_variant gen_var;
+
+    if (argc != 2) {
+        printf("%s", HELP);
+        return 1;
+    }
+
+    if (0 == strcmp(argv[1], "-header")) {
+        gen_var = GEN_OFFSET;
+    }
+    else if (0 == strcmp(argv[1], "-index")) {
+        gen_var = GEN_INDEX;
+    }
+    else if (0 == strcmp(argv[1], "-table")) {
+        gen_var = GEN_TABLE;
+    }
+    else {
+        printf("%s", HELP);
+        return 1;
+    }
+    return generateJvmOffsets(gen_var);
+}
diff -Nru jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris
--- jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris	2024-12-29 15:20:25.107563620 +0100
@@ -0,0 +1,25 @@
+#
+# Copyright (c) 2016, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+#
+
+JVM_handle_solaris_signal
+sysThreadAvailableStackWithSlack
diff -Nru jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris-dtrace-compiler1 jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris-dtrace-compiler1
--- jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris-dtrace-compiler1	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris-dtrace-compiler1	2024-12-29 15:20:25.107801381 +0100
@@ -0,0 +1,34 @@
+#
+# Copyright (c) 2016, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+#
+
+__1cGMethodG__vtbl_
+__1cHnmethodG__vtbl_
+__1cICodeBlobG__vtbl_
+__1cIUniverseO_collectedHeap_
+__1cJCodeCacheG_heaps_
+__1cKBufferBlobG__vtbl_
+__1cLRuntimeStubG__vtbl_
+__1cNSafepointBlobG__vtbl_
+__1cSDeoptimizationBlobG__vtbl_
+
+__JvmOffsets
diff -Nru jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris-dtrace-compiler2 jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris-dtrace-compiler2
--- jdk24u-jdk-24-29.orig/make/hotspot/symbols/symbols-solaris-dtrace-compiler2	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/make/hotspot/symbols/symbols-solaris-dtrace-compiler2	2024-12-29 15:20:25.108039628 +0100
@@ -0,0 +1,36 @@
+#
+# Copyright (c) 2016, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+#
+
+__1cGMethodG__vtbl_
+__1cHnmethodG__vtbl_
+__1cICodeBlobG__vtbl_
+__1cIUniverseO_collectedHeap_
+__1cJCodeCacheG_heaps_
+__1cKBufferBlobG__vtbl_
+__1cLRuntimeStubG__vtbl_
+__1cNSafepointBlobG__vtbl_
+__1cSDeoptimizationBlobG__vtbl_
+__1cNExceptionBlobG__vtbl_
+__1cQUncommonTrapBlobG__vtbl_
+
+__JvmOffsets
diff -Nru jdk24u-jdk-24-29.orig/make/ide/visualstudio/hotspot/CreateVSProject.gmk jdk24u-jdk-24-29/make/ide/visualstudio/hotspot/CreateVSProject.gmk
--- jdk24u-jdk-24-29.orig/make/ide/visualstudio/hotspot/CreateVSProject.gmk	2024-12-29 15:19:40.989281916 +0100
+++ jdk24u-jdk-24-29/make/ide/visualstudio/hotspot/CreateVSProject.gmk	2024-12-29 15:20:25.055136902 +0100
@@ -76,6 +76,7 @@
     -ignorePath linux \
     -ignorePath posix \
     -ignorePath ppc \
+    -ignorePath solaris \
     -ignorePath x86_32 \
     -ignorePath zero \
       #
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.base/Copy.gmk jdk24u-jdk-24-29/make/modules/java.base/Copy.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.base/Copy.gmk	2024-12-29 15:19:40.941628254 +0100
+++ jdk24u-jdk-24-29/make/modules/java.base/Copy.gmk	2024-12-29 15:20:25.055545714 +0100
@@ -148,7 +148,7 @@
 
 TARGETS += $(NET_PROPERTIES_DST)
 
-ifeq ($(call isTargetOs, linux), true)
+ifeq ($(call isTargetOs, solaris linux), true)
   $(eval $(call SetupCopyFiles, COPY_SDP_CONF, \
       FILES := $(TOPDIR)/src/java.base/$(OPENJDK_TARGET_OS_TYPE)/conf/sdp/sdp.conf.template, \
       DEST := $(CONF_DST_DIR)/sdp, \
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.base/gensrc/GensrcMisc.gmk jdk24u-jdk-24-29/make/modules/java.base/gensrc/GensrcMisc.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.base/gensrc/GensrcMisc.gmk	2024-12-29 15:19:40.942589672 +0100
+++ jdk24u-jdk-24-29/make/modules/java.base/gensrc/GensrcMisc.gmk	2024-12-29 15:20:25.056346896 +0100
@@ -136,6 +136,21 @@
 
 endif
 
+################################################################################
+
+ifeq ($(call isTargetOs, solaris), true)
+
+  GENSRC_SC_FILE := $(SUPPORT_OUTPUTDIR)/gensrc/java.base/sun/nio/fs/SolarisConstants.java
+
+  $(GENSRC_SC_FILE): \
+      $(TOPDIR)/src/java.base/solaris/classes/sun/nio/fs/SolarisConstants.java.template
+	$(generate-preproc-src)
+
+  TARGETS += $(GENSRC_SC_FILE)
+
+endif
+
+################################################################################
 # Create the javax/crypto/JceSecurity.class, using the build default.
 #
 ifeq ($(UNLIMITED_CRYPTO), true)
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.base/lib/CoreLibraries.gmk jdk24u-jdk-24-29/make/modules/java.base/lib/CoreLibraries.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.base/lib/CoreLibraries.gmk	2024-12-29 15:19:40.943721691 +0100
+++ jdk24u-jdk-24-29/make/modules/java.base/lib/CoreLibraries.gmk	2024-12-29 15:20:25.056869920 +0100
@@ -28,7 +28,7 @@
 ################################################################################
 
 LIBVERIFY_OPTIMIZATION := HIGH
-ifeq ($(call isTargetOs, linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
+ifeq ($(call isTargetOs, solaris linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
   LIBVERIFY_OPTIMIZATION := LOW
 endif
 
@@ -63,6 +63,7 @@
     DISABLED_WARNINGS_clang_TimeZone_md.c := unused-variable, \
     JDK_LIBS := libjvm, \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := -lsocket -lnsl -lscf $(LIBDL), \
     LIBS_aix := $(LIBDL) $(LIBM), \
     LIBS_macosx := \
         -framework CoreFoundation \
@@ -183,6 +184,7 @@
     DISABLED_WARNINGS_clang_java_md_macosx.m := unused-variable, \
     LIBS_unix := $(LIBZ_LIBS), \
     LIBS_linux := $(LIBDL) -lpthread, \
+    LIBS_solaris := $(LIBDL), \
     LIBS_macosx := \
         -framework ApplicationServices \
         -framework Cocoa \
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.base/Lib.gmk jdk24u-jdk-24-29/make/modules/java.base/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.base/Lib.gmk	2024-12-29 15:19:40.944753774 +0100
+++ jdk24u-jdk-24-29/make/modules/java.base/Lib.gmk	2024-12-29 15:20:25.055981968 +0100
@@ -58,6 +58,7 @@
         -delayload:winhttp.dll, \
     JDK_LIBS := libjava libjvm, \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := -lnsl -lsocket $(LIBDL), \
     LIBS_aix := $(LIBDL), \
     LIBS_windows := advapi32.lib delayimp.lib iphlpapi.lib secur32.lib \
         winhttp.lib ws2_32.lib, \
@@ -81,8 +82,9 @@
         libjvm, \
     DISABLED_WARNINGS_clang_Net.c := unused-function unused-variable, \
     DISABLED_WARNINGS_clang_UnixNativeDispatcher.c := unused-variable, \
-    JDK_LIBS := libjava libnet, \
+    JDK_LIBS := libjava libjvm libnet, \
     LIBS_linux := $(LIBDL) -lpthread, \
+    LIBS_solaris := -lsocket -lposix4 $(LIBDL) -lsendfile, \
     LIBS_aix := $(LIBDL), \
     LIBS_macosx := \
         -framework CoreFoundation \
@@ -124,6 +126,7 @@
       DISABLED_WARNINGS_gcc_jsig.c := unused-but-set-variable, \
       DISABLED_WARNINGS_clang_jsig.c := unused-but-set-variable, \
       LIBS_linux := $(LIBDL), \
+      LIBS_solaris := $(LIBDL), \
       LIBS_aix := $(LIBDL), \
   ))
 
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.desktop/Gensrc.gmk jdk24u-jdk-24-29/make/modules/java.desktop/Gensrc.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.desktop/Gensrc.gmk	2024-12-29 15:19:40.967927385 +0100
+++ jdk24u-jdk-24-29/make/modules/java.desktop/Gensrc.gmk	2024-12-29 15:20:25.057303377 +0100
@@ -32,7 +32,7 @@
   include gensrc/GensrcIcons.gmk
 endif
 
-ifeq ($(call isTargetOs, linux aix), true)
+ifeq ($(call isTargetOs, linux solaris aix), true)
   include gensrc/GensrcX11Wrappers.gmk
 endif
 
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.desktop/lib/AwtLibraries.gmk jdk24u-jdk-24-29/make/modules/java.desktop/lib/AwtLibraries.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.desktop/lib/AwtLibraries.gmk	2024-12-29 15:19:40.968409202 +0100
+++ jdk24u-jdk-24-29/make/modules/java.desktop/lib/AwtLibraries.gmk	2024-12-29 15:20:25.058308807 +0100
@@ -57,7 +57,7 @@
       #
 endif
 
-ifeq ($(call isTargetOs, linux macosx aix), true)
+ifeq ($(call isTargetOs, solaris linux macosx aix), true)
   LIBAWT_EXCLUDE_FILES += awt_Font.c CUPSfuncs.c fontpath.c X11Color.c
 endif
 
@@ -123,6 +123,7 @@
     JDK_LIBS := java.base:libjava java.base:libjvm, \
     LIBS_unix := $(LIBM), \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := $(LIBDL), \
     LIBS_aix := $(LIBDL), \
     LIBS_macosx := \
         -framework ApplicationServices \
@@ -188,8 +189,9 @@
       DISABLED_WARNINGS_gcc_X11SurfaceData.c := unused-function, \
       DISABLED_WARNINGS_clang_X11Renderer.c := unused-function, \
       DISABLED_WARNINGS_clang_X11SurfaceData.c := unused-function, \
-      JDK_LIBS := libawt java.base:libjava, \
+      JDK_LIBS := libawt java.base:libjava java.base:libjvm, \
       LIBS_linux := $(LIBDL) $(LIBM), \
+      LIBS_solaris := $(LIBDL) $(LIBM) $(LIBCXX), \
       STATIC_LIB_EXCLUDE_OBJS := $(LIBAWT_HEADLESS_STATIC_EXCLUDE_OBJS), \
   ))
 
@@ -278,7 +280,7 @@
       DISABLED_WARNINGS_clang_aix_sun_awt_X11_GtkFileDialogPeer.c := \
           parentheses, \
       DISABLED_WARNINGS_clang_aix_awt_InputMethod.c := unused-function sign-compare, \
-      JDK_LIBS := libawt java.base:libjava, \
+      JDK_LIBS := libawt java.base:libjava java.base:libjvm, \
       LIBS_unix := $(LIBDL) $(LIBM) $(X_LIBS) -lX11 -lXext -lXi -lXrender \
           -lXtst, \
       LIBS_linux := -lpthread, \
@@ -399,7 +401,7 @@
 endif
 
 ifeq ($(call isTargetOsType, unix)+$(call isTargetOs, macosx), true+false)
-  LIBJAWT_JDK_LIBS_unix := libawt
+  LIBJAWT_JDK_LIBS_unix := libawt java.base:libjava java.base:libjvm
   ifeq ($(ENABLE_HEADLESS_ONLY), false)
     LIBJAWT_JDK_LIBS_unix += libawt_xawt
   else
@@ -419,6 +421,7 @@
     LDFLAGS_windows := $(LDFLAGS_CXX_JDK), \
     LDFLAGS_macosx := -Wl$(COMMA)-rpath$(COMMA)@loader_path, \
     JDK_LIBS_unix := $(LIBJAWT_JDK_LIBS_unix), \
+    LIBS_solaris := $(X_LIBS) -lXrender, \
     JDK_LIBS_windows := libawt, \
     JDK_LIBS_macosx := libawt_lwawt, \
     LIBS_macosx := -framework Cocoa, \
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.desktop/lib/ClientLibraries.gmk jdk24u-jdk-24-29/make/modules/java.desktop/lib/ClientLibraries.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.desktop/lib/ClientLibraries.gmk	2024-12-29 15:19:40.968231334 +0100
+++ jdk24u-jdk-24-29/make/modules/java.desktop/lib/ClientLibraries.gmk	2024-12-29 15:20:25.058848583 +0100
@@ -88,7 +88,7 @@
     DISABLED_WARNINGS_gcc := format-nonliteral stringop-truncation type-limits \
         unused-variable, \
     DISABLED_WARNINGS_clang := format-nonliteral, \
-    JDK_LIBS := libawt java.base:libjava, \
+    JDK_LIBS := libawt java.base:libjava java.base:libjvm, \
     LIBS_unix := $(LCMS_LIBS) $(LIBM), \
 ))
 
@@ -125,7 +125,7 @@
     DISABLED_WARNINGS_gcc_jcmaster.c := implicit-fallthrough, \
     DISABLED_WARNINGS_gcc_jdphuff.c := shift-negative-value, \
     DISABLED_WARNINGS_clang_imageioJPEG.c := unused-but-set-variable, \
-    JDK_LIBS := java.base:libjava, \
+    JDK_LIBS := java.base:libjava java.base:libjvm, \
     LIBS := $(LIBJPEG_LIBS), \
 ))
 
@@ -258,6 +258,7 @@
       LIBS := $(GIFLIB_LIBS) $(LIBJPEG_LIBS) $(LIBZ_LIBS) $(PNG_LIBS), \
       LIBS_unix := $(LIBM) -lpthread, \
       LIBS_linux := $(LIBDL) $(X_LIBS) -lX11 -lXext, \
+      LIBS_solaris := $(LIBDL) $(X_LIBS) -lX11 -lXext, \
       LIBS_macosx := -liconv \
           -framework ApplicationServices \
           -framework Cocoa \
@@ -307,7 +308,7 @@
         -DHAVE_SYSCONF -DHAVE_SYS_MMAN_H -DHAVE_UNISTD_H \
         -DHB_NO_PRAGMA_GCC_DIAGNOSTIC
   endif
-  ifeq ($(call isTargetOs, linux macosx), true)
+  ifeq ($(call isTargetOs, solaris linux macosx), true)
     HARFBUZZ_CFLAGS += -DHAVE_INTEL_ATOMIC_PRIMITIVES -DHB_NO_VISIBILITY
   endif
 
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.desktop/Lib.gmk jdk24u-jdk-24-29/make/modules/java.desktop/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.desktop/Lib.gmk	2024-12-29 15:19:40.966758458 +0100
+++ jdk24u-jdk-24-29/make/modules/java.desktop/Lib.gmk	2024-12-29 15:20:25.057641020 +0100
@@ -48,10 +48,15 @@
       -DX_PLATFORM=X_$(OPENJDK_TARGET_OS_UPPERCASE) \
       -DUSE_PORTS=TRUE \
       -DUSE_DAUDIO=TRUE \
-      -DUSE_PLATFORM_MIDI_OUT=TRUE \
-      -DUSE_PLATFORM_MIDI_IN=TRUE \
       #
 
+  ifeq ($(call isTargetOs, solaris), false)
+    LIBJSOUND_CFLAGS += \
+        -DUSE_PLATFORM_MIDI_OUT=TRUE \
+        -DUSE_PLATFORM_MIDI_IN=TRUE \
+        #
+  endif
+
   LIBJSOUND_LINK_TYPE := C
   ifeq ($(call isTargetOs, macosx), true)
     LIBJSOUND_LINK_TYPE := C++
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.instrument/Lib.gmk jdk24u-jdk-24-29/make/modules/java.instrument/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.instrument/Lib.gmk	2024-12-29 15:19:40.960757682 +0100
+++ jdk24u-jdk-24-29/make/modules/java.instrument/Lib.gmk	2024-12-29 15:20:25.059240721 +0100
@@ -39,6 +39,7 @@
     JDK_LIBS := java.base:libjava java.base:libjli java.base:libjvm, \
     LIBS_unix := $(LIBZ_LIBS), \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := $(LIBDL), \
     LIBS_aix := $(LIBDL) -liconv, \
     LIBS_macosx := -liconv \
         -framework ApplicationServices \
diff -Nru jdk24u-jdk-24-29.orig/make/modules/java.management/Lib.gmk jdk24u-jdk-24-29/make/modules/java.management/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/java.management/Lib.gmk	2024-12-29 15:19:40.969810894 +0100
+++ jdk24u-jdk-24-29/make/modules/java.management/Lib.gmk	2024-12-29 15:20:25.059651103 +0100
@@ -30,7 +30,7 @@
 ################################################################################
 
 LIBMANAGEMENT_OPTIMIZATION := HIGH
-ifeq ($(call isTargetOs, linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
+ifeq ($(call isTargetOs, solaris linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
   LIBMANAGEMENT_OPTIMIZATION := LOW
 endif
 
@@ -40,6 +40,7 @@
     DISABLED_WARNINGS_gcc_VMManagementImpl.c := unused-variable, \
     DISABLED_WARNINGS_clang_VMManagementImpl.c := unused-variable, \
     JDK_LIBS := java.base:libjava java.base:libjvm, \
+    LIBS_solaris := -lkstat, \
     LIBS_aix := -lperfstat, \
     LIBS_windows := advapi32.lib psapi.lib, \
 ))
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.attach/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.attach/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.attach/Lib.gmk	2024-12-29 15:19:40.955644587 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.attach/Lib.gmk	2024-12-29 15:20:25.060027203 +0100
@@ -41,7 +41,8 @@
     OPTIMIZATION := LOW, \
     CFLAGS := $(LIBATTACH_CFLAGS), \
     CFLAGS_windows := -Gy, \
-    JDK_LIBS := java.base:libjava, \
+    JDK_LIBS := java.base:libjava java.base:libjvm, \
+    LIBS_solaris := -ldoor, \
     LIBS_windows := advapi32.lib psapi.lib, \
 ))
 
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.crypto.cryptoki/Copy.gmk jdk24u-jdk-24-29/make/modules/jdk.crypto.cryptoki/Copy.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.crypto.cryptoki/Copy.gmk	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.crypto.cryptoki/Copy.gmk	2024-12-29 15:20:25.108324877 +0100
@@ -0,0 +1,45 @@
+#
+# Copyright (c) 2014, 2019, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.  Oracle designates this
+# particular file as subject to the "Classpath" exception as provided
+# by Oracle in the LICENSE file that accompanied this code.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+#
+
+include CopyCommon.gmk
+
+################################################################################
+
+ifeq ($(call isTargetOs, solaris), true)
+
+  SUNPKCS11_CFG_SRC := \
+      $(TOPDIR)/src/jdk.crypto.cryptoki/solaris/conf/security/sunpkcs11-solaris.cfg
+  SUNPKCS11_CFG_DST := $(CONF_DST_DIR)/security/sunpkcs11-solaris.cfg
+
+  $(SUNPKCS11_CFG_DST): $(SUNPKCS11_CFG_SRC)
+	$(call install-file)
+
+  SECURITY_PKCS11_CONF_FILES += $(SUNPKCS11_CFG_DST)
+
+  TARGETS := $(SUNPKCS11_CFG_DST)
+
+endif
+
+################################################################################
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.hotspot.agent/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.hotspot.agent/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.hotspot.agent/Lib.gmk	2024-12-29 15:19:40.962661958 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.hotspot.agent/Lib.gmk	2024-12-29 15:20:25.060416388 +0100
@@ -68,8 +68,9 @@
     CFLAGS := $(LIBSAPROC_CFLAGS), \
     CXXFLAGS := $(LIBSAPROC_CFLAGS) $(LIBSAPROC_CXXFLAGS), \
     EXTRA_SRC := $(LIBSAPROC_EXTRA_SRC), \
-    JDK_LIBS := java.base:libjava, \
+    JDK_LIBS := java.base:libjava java.base:libjvm, \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := -ldl -lstdc++ -lthread -lproc, \
     LIBS_macosx := \
         -framework CoreFoundation \
         -framework Foundation \
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.jdwp.agent/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.jdwp.agent/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.jdwp.agent/Lib.gmk	2024-12-29 15:19:40.961157832 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.jdwp.agent/Lib.gmk	2024-12-29 15:20:25.060832362 +0100
@@ -37,6 +37,7 @@
         include \
         libjdwp/export, \
     LIBS_linux := -lpthread, \
+    LIBS_solaris := -lnsl -lsocket, \
     LIBS_windows := iphlpapi.lib ws2_32.lib, \
 ))
 
@@ -72,6 +73,7 @@
         java.base:libjava, \
     JDK_LIBS := java.base:libjvm, \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := $(LIBDL), \
     LIBS_macosx := -liconv, \
     LIBS_aix := -liconv, \
 ))
